/*
 * (C) COPYRIGHT 2012 CRZ
 *
 * File Name : ad7321.h
 * Author    : POOH
 * Version   : V1.0
 * Date      : 07/10/2012
 * AD7321 ADC driver
 */

#ifndef __AD7321_H
#define __AD7321_H

//#define AD7321_DEBUG
#ifdef AD7321_DEBUG
#define AD7321PRINTK(fmt, args...) \
	printf("[AD7321] %s(%d): " fmt, __func__, __LINE__ , ## args)
#else
#define AD7321PRINTK(fmt, args...)
#endif

/*
 * Default parameters
 */

#define AD7321_WRITE_BIT           0x8000
#define AD7321_REG_SELECT_CONTROL  0x0000
#define AD7321_REG_SELECT_RANGE    0x2000

#define AD7321_RANGE_CH0_PN_10    0x0000
#define AD7321_RANGE_CH0_PN_5     0x0800
#define AD7321_RANGE_CH0_PN_2_5   0x1000
#define AD7321_RANGE_CH0_0_TO_10  0x1800

#define AD7321_RANGE_CH1_PN_10    0x0000
#define AD7321_RANGE_CH1_PN_5     0x0080
#define AD7321_RANGE_CH1_PN_2_5   0x0100
#define AD7321_RANGE_CH1_0_TO_10  0x0180

#define AD7321_CTRL_CHANNEL_0      0x000
#define AD7321_CTRL_CHANNEL_1      0x400

#define AD7321_CTRL_REF_ENABLE     0x00
#define AD7321_CTRL_REF_DISABLE    0x10

#define AD7321_CTRL_REF_CODING_TWOS_COMPLEMENT  0x00
#define AD7321_CTRL_REF_CODING_STRAIGHT_BINARY  0x20

#define AD7321_CTRL_SEQUENCE       0x8

#define AD7321_IOCTL_SET_CHANNEL    0x31
#define AD7321_IOCTL_GET_ADC_DATA   0x32

void AD7321_HW_Init(void);

int Set_AD7321_ADC_Channel(int channel);
int Get_AD7321_ADC_Data(int channel);

#endif  /* __AD7321_H */

