/*
 * AT86RF212_mango_porting.h
 */

#ifndef __AT86RF212_MANGO_PORTING_H
#define __AT86RF212_MANGO_PORTING_H

/* Includes ------------------------------------------------------------------*/

#include "hw_config.h"
#include "stm32f10x_spi.h"
#include "hal_types.h"
#include "stm32f10x_gpio.h"

/* Exported types ------------------------------------------------------------*/

/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/

#define GPIO_PORTSOURCE_AT86RF212_GPIO0   GPIO_PortSourceGPIOD

#define AT86RF212_SPI_BEGIN()  GPIO_ResetBits(g_at86rf212_gpio_ncs, g_at86rf212_gpio_pin_ncs)
#define AT86RF212_SPI_END()    GPIO_SetBits(g_at86rf212_gpio_ncs, g_at86rf212_gpio_pin_ncs)

/* External variables --------------------------------------------------------*/

/* Exported functions ------------------------------------------------------- */

void AT86RF212_GPIO_0_Interrupt_Setting(FunctionalState  fStateE);
void AT86RF212_RESET(void);

void AT86RF212_SPI_TX(u8 data);
u8 AT86RF212_SPI_RX(void);
void AT86RF212_SPI_WAIT_RXRDY(void);
uint8 AT86RF212_SPI_TXRX(uint8 x);

#endif  /* __AT86RF212_MANGO_PORTING_H */

