/*
 * clcd_lmc1623.h
 */

#ifndef __CPLD_LMC1623_H
#define __CPLD_LMC1623_H

/* Includes ------------------------------------------------------------------*/

#include "hw_config.h"

/* Exported types ------------------------------------------------------------*/

/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/

#define LMC1623_LCD_ENABLE()      GPIO_SetBits(GPIO_LCD_CTRL, GPIO_LCD_ENABLE_PIN)
#define LMC1623_LCD_DISABLE()     GPIO_ResetBits(GPIO_LCD_CTRL, GPIO_LCD_ENABLE_PIN)
#define LMC1623_LCD_RS_DATA()     GPIO_SetBits(GPIO_LCD_CTRL, GPIO_LCD_RS_PIN)
#define LMC1623_LCD_RS_CONTROL()  GPIO_ResetBits(GPIO_LCD_CTRL, GPIO_LCD_RS_PIN)
#define LMC1623_LCD_READ()        GPIO_SetBits(GPIO_LCD_CTRL, GPIO_LCD_NRW_PIN)
#define LMC1623_LCD_WRITE()       GPIO_ResetBits(GPIO_LCD_CTRL, GPIO_LCD_NRW_PIN)

/* External variables --------------------------------------------------------*/

/* Exported functions ------------------------------------------------------- */

void CLCD_Init(void);
void CLCD_ClearLine(u8 lineNum);

void CLCD_Write_String(u8 lineNum, char * str_p);
void CLCD_Write_String_wFormat(u8 lineNum, const char * format_str_p, ...);

void CLCD_Write_Num(u8 lineNum, int n);
void CLCD_Write_Float(u8 lineNum, long double f);

#endif  /* __CPLD_LMC1623_H */
