/*
 * DAC101C08 DAC driver
 */

#include "hw_config.h"

extern uint8_t Buffer_Rx1[];
extern uint8_t Buffer_Tx1[];

#define I2C_SLAVE_ADDR_DAC101C085          0x18 /* 0001 100 */

#define DAC101C08_DAC_MAX_VALUE  0xFFC
#define DAC101C08_UP_DOWN_SIZE   0x10

/*
 * device operation
 */

void DAC101C08_Dac_Value_Up(void)
{
    u16 dacVal;
    u16 dacValRx = DAC101C08_Get_Dac_Value();

    if((dacValRx + DAC101C08_UP_DOWN_SIZE) > DAC101C08_DAC_MAX_VALUE)
        dacVal = DAC101C08_DAC_MAX_VALUE;
    else
        dacVal = dacValRx + DAC101C08_UP_DOWN_SIZE;

    DAC101C08_Set_Dac_Value(dacVal);
    printf("%s() old DacVal: %X, new DacVAl: %X\n", __func__, dacValRx, dacVal);
}

void DAC101C08_Dac_Value_Down(void)
{
    u16 dacVal;
    u16 dacValRx = DAC101C08_Get_Dac_Value();

    if(dacValRx < DAC101C08_UP_DOWN_SIZE)
        dacVal = 0;
    else
        dacVal = dacValRx - DAC101C08_UP_DOWN_SIZE;

    DAC101C08_Set_Dac_Value(dacVal);
    printf("%s() old DacVal: %X, new DacVAl: %X\n", __func__, dacValRx, dacVal);
}

u16 DAC101C08_Get_Dac_Value(void)
{
    u16 dacValRx;

    I2C_Master_BufferRead(I2C1, Buffer_Rx1, 2, Polling, I2C_SLAVE_ADDR_DAC101C085);
    dacValRx = Buffer_Rx1[0];
    dacValRx = (dacValRx << 8) | Buffer_Rx1[1];

    return dacValRx;
}

void DAC101C08_Set_Dac_Value(u16 dacVal)
{
    if(dacVal > DAC101C08_DAC_MAX_VALUE)
        dacVal = DAC101C08_DAC_MAX_VALUE;

    Buffer_Tx1[0] = (dacVal >> 8) & 0xF;
    Buffer_Tx1[1] = dacVal & 0xFF;
    I2C_Master_BufferWrite(I2C1, Buffer_Tx1, 2, Interrupt, I2C_SLAVE_ADDR_DAC101C085);
}

