/*
 * enc28j60_mango_porting.c
 */

#include "enc28j60_mango_porting.h"
#include "misc.h"
#include "stm32f10x_exti.h"
#include "stm32f10x_gpio.h"

void ENC28J60_RESET_OPIN(u8 data)
{
    if(0 == data)
    {
        GPIO_SetBits(GPIO_SPI_IO, g_enc28j60_gpio_pin_reset);
    }
    else
    {
        GPIO_ResetBits(GPIO_SPI_IO, g_enc28j60_gpio_pin_reset);
    }
}

void ENC28J60_SPI_TX(u8 data)
{
    /* Wait for SPI Tx buffer empty */
    while (SPI_I2S_GetFlagStatus(g_enc28j60_spi_num_p, SPI_I2S_FLAG_TXE) == RESET);
    /* Send SPI1 data */
    SPI_I2S_SendData(g_enc28j60_spi_num_p, data);
}

u8 ENC28J60_SPI_RX(void)
{
    return SPI_I2S_ReceiveData(g_enc28j60_spi_num_p);
}

void ENC28J60_SPI_WAIT_RXRDY(void)
{
    /* Wait for SPI1 data reception */
    while (SPI_I2S_GetFlagStatus(g_enc28j60_spi_num_p, SPI_I2S_FLAG_RXNE) == RESET);
}

uint8 ENC28J60_SPI_TXRX(uint8 x)
{
    ENC28J60_SPI_TX(x);
    ENC28J60_SPI_WAIT_RXRDY();
    return ENC28J60_SPI_RX();
}

