/*
 * enc28j60_mango_porting.h
 */

#ifndef __ENC28J60_MANGO_PORTING_H
#define __ENC28J60_MANGO_PORTING_H

/* Includes ------------------------------------------------------------------*/

#include "hw_config.h"
#include "stm32f10x_spi.h"
#include "hal_types.h"
#include "stm32f10x_gpio.h"

/* Exported types ------------------------------------------------------------*/

/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/

#define ENC28J60_SPI_BEGIN()  GPIO_ResetBits(g_enc28j60_gpio_ncs, g_enc28j60_gpio_pin_ncs);
#define ENC28J60_SPI_END()    GPIO_SetBits(g_enc28j60_gpio_ncs, g_enc28j60_gpio_pin_ncs)

/* External variables --------------------------------------------------------*/

/* Exported functions ------------------------------------------------------- */

/* CC112X specific prototype function */

void ENC28J60_SPI_TX(u8 data);
u8 ENC28J60_SPI_RX(void);
void ENC28J60_SPI_WAIT_RXRDY(void);
uint8 ENC28J60_SPI_TXRX(uint8 x);

#endif  /* __ENC28J60_MANGO_PORTING_H */

