/*
 * cc1120_mango_porting.c
 */

#include "cc1120_mango_porting.h"
#include "misc.h"
#include "stm32f10x_exti.h"
#include "stm32f10x_gpio.h"
#include "hw_config.h"

static void trxReadWriteBurstSingle(uint8 addr,uint8 *pData,uint16 len);

void CC1120_SPI_BEGIN(void)
{
/*
    GPIO_InitTypeDef GPIO_InitStructure;

    if(SPI1 == g_cc1120_spi_num_p)
    {
        // Configure SPI1 pins: MISO ---------------------------------
        GPIO_InitStructure.GPIO_Pin   = GPIO_SPI_1_MISO_PIN;
        GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN_FLOATING;
        GPIO_Init(GPIO_SPI_1, &GPIO_InitStructure);
    }
    else
    {
        // Configure SPI2 pins: MISO ---------------------------------
        GPIO_InitStructure.GPIO_Pin   = GPIO_SPI_2_MISO_PIN;
        GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_IN_FLOATING;
        GPIO_Init(GPIO_SPI_2, &GPIO_InitStructure);
    }
*/

    GPIO_ResetBits(g_cc1120_gpio_ncs, g_cc1120_gpio_pin_ncs);

    Delay(2);

/*
    while(1)
    {
        if(SPI1 == g_cc1120_spi_num_p)
        {
            if(Bit_RESET == GPIO_ReadInputDataBit(GPIO_SPI_1, GPIO_SPI_1_MISO_PIN))
                break;
        }
        else
        {
            if(Bit_RESET == GPIO_ReadInputDataBit(GPIO_SPI_2, GPIO_SPI_2_MISO_PIN))
                break;
        }
    }
*/

/*
    if(SPI1 == g_cc1120_spi_num_p)
    {
        // Configure SPI1 pins: MISO ---------------------------------
        GPIO_InitStructure.GPIO_Pin   = GPIO_SPI_1_MISO_PIN;
        GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;
        GPIO_Init(GPIO_SPI_1, &GPIO_InitStructure);
    }
    else
    {
        // Configure SPI2 pins: MISO ---------------------------------
        GPIO_InitStructure.GPIO_Pin   = GPIO_SPI_2_MISO_PIN;
        GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
        GPIO_InitStructure.GPIO_Mode  = GPIO_Mode_AF_PP;
        GPIO_Init(GPIO_SPI_2, &GPIO_InitStructure);
    }
*/
}

void CC1120_SPI_END(void)
{
    Delay(2);
    GPIO_SetBits(g_cc1120_gpio_ncs, g_cc1120_gpio_pin_ncs);
    Delay(2);
}

void CC1120_GPIO_0_Interrupt_Setting(FunctionalState  fStateE)
{
    NVIC_InitTypeDef NVIC_InitStructure;
    EXTI_InitTypeDef EXTI_InitStructure;

    /* Configure one bit for preemption priority */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

    /* Enable the Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel                   = g_cc1120_gpio_pin_5_irq;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority        = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd                = fStateE;
    NVIC_Init(&NVIC_InitStructure);

    /* Connect EXTI Line to gpio pin */
    GPIO_EXTILineConfig(GPIO_PORTSOURCE_CC1120_GPIO, g_cc1120_gpio_pin_5_pin_source);

    /* Configure EXTI Line to generate an interrupt */
    EXTI_ClearITPendingBit(g_cc1120_gpio_pin_5_exti_line);

    EXTI_InitStructure.EXTI_Line    = g_cc1120_gpio_pin_5_exti_line;
    EXTI_InitStructure.EXTI_Mode    = EXTI_Mode_Interrupt;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
    EXTI_InitStructure.EXTI_LineCmd = fStateE;
    EXTI_Init(&EXTI_InitStructure);
}

void CC1120_GPIO_2_Interrupt_Setting(FunctionalState  fStateE)
{
    NVIC_InitTypeDef NVIC_InitStructure;
    EXTI_InitTypeDef EXTI_InitStructure;

    /* Configure one bit for preemption priority */
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_1);

    /* Enable the Interrupt */
    NVIC_InitStructure.NVIC_IRQChannel                   = g_cc1120_gpio_pin_6_irq;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority        = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd                = fStateE;
    NVIC_Init(&NVIC_InitStructure);

    /* Connect EXTI Line to gpio pin */
    GPIO_EXTILineConfig(GPIO_PORTSOURCE_CC1120_GPIO, g_cc1120_gpio_pin_6_pin_source);

    /* Configure EXTI Line to generate an interrupt */
    EXTI_ClearITPendingBit(g_cc1120_gpio_pin_6_exti_line);

    EXTI_InitStructure.EXTI_Line    = g_cc1120_gpio_pin_6_exti_line;
    EXTI_InitStructure.EXTI_Mode    = EXTI_Mode_Interrupt;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
    EXTI_InitStructure.EXTI_LineCmd = fStateE;
    EXTI_Init(&EXTI_InitStructure);
}

// SPI access macros
// #define CC2520_SPI_BEGIN()      st( CC2520_CSN_OPIN(0); )
// #define CC2520_SPI_TX(x)        st( CC2520_SPI_RX_NOT_READY(); CC2520_SPI_TX_REG = x; )
// #define CC2520_SPI_RX()         (CC2520_SPI_RX_REG)
// #define CC2520_SPI_WAIT_RXRDY() st( while (!CC2520_SPI_RX_IS_READY()); )
// #define CC2520_SPI_END()        st( CC2520_CSN_OPIN(1); )

void CC1120_RESET_OPIN(u8 data)
{
    if(0 == data)
    {
        GPIO_SetBits(GPIO_SPI_IO, g_cc1120_gpio_pin_reset);
    }
    else
    {
        GPIO_ResetBits(GPIO_SPI_IO, g_cc1120_gpio_pin_reset);
    }
}

void CC1120_SPI_TX(u8 data)
{
    /* Wait for SPI1 Tx buffer empty */
    while (SPI_I2S_GetFlagStatus(g_cc1120_spi_num_p, SPI_I2S_FLAG_TXE) == RESET);
    /* Send SPI1 data */
    SPI_I2S_SendData(g_cc1120_spi_num_p, data);
}

u8 CC1120_SPI_RX(void)
{
    uint16_t  spi_rx_data;
    spi_rx_data = SPI_I2S_ReceiveData(g_cc1120_spi_num_p);
//    printf("CC1120_SPI_RX() spi_rx_data: 0x%02X\n", spi_rx_data);
    return spi_rx_data;
}

void CC1120_SPI_WAIT_RXRDY(void)
{
    /* Wait for SPI1 data reception */
    while (SPI_I2S_GetFlagStatus(g_cc1120_spi_num_p, SPI_I2S_FLAG_RXNE) == RESET);
}

uint8 CC1120_SPI_TXRX(uint8 x)
{
    CC1120_SPI_TX(x);
    CC1120_SPI_WAIT_RXRDY();
    return CC1120_SPI_RX();
}

/*******************************************************************************
 * @fn          trx8BitRegAccess
 *
 * @brief       This function performs a read or write from/to a 8bit register
 *              address space. The function handles burst and single read/write
 *              as specfied in addrByte. Function assumes that chip is ready.
 *
 * input parameters
 *
 * @param       accessType - Specifies if this is a read or write and if it's
 *                           a single or burst access. Bitmask made up of
 *                           RADIO_BURST_ACCESS/RADIO_SINGLE_ACCESS/
 *                           RADIO_WRITE_ACCESS/RADIO_READ_ACCESS.
 * @param       addrByte - address byte of register.
 * @param       pData    - data array
 * @param       len      - Length of array to be read(TX)/written(RX)
 *
 * output parameters
 *
 * @return      chip status
 */
rfStatus_t trx8BitRegAccess(uint8 accessType, uint8 addrByte, uint8 *pData, uint16 len)
{
    uint8 readValue;

    CC1120_SPI_BEGIN();

    /* send register address byte */
    /* Storing chip status */
    readValue = CC1120_SPI_TXRX(accessType|addrByte);
//    printf("trx8BitRegAccess() readValue: 0x%02X\n", readValue);
    trxReadWriteBurstSingle(accessType|addrByte,pData,len);

    CC1120_SPI_END();

    /* return the status byte value */
    return(readValue);
}

/******************************************************************************
 * @fn          trx16BitRegAccess
 *
 * @brief       This function performs a read or write in the extended adress
 *              space of CC112X.
 *
 * input parameters
 *
 * @param       accessType - Specifies if this is a read or write and if it's
 *                           a single or burst access. Bitmask made up of
 *                           RADIO_BURST_ACCESS/RADIO_SINGLE_ACCESS/
 *                           RADIO_WRITE_ACCESS/RADIO_READ_ACCESS.
 * @param       extAddr - Extended register space address = 0x2F.
 * @param       regAddr - Register address in the extended address space.
 * @param       *pData  - Pointer to data array for communication
 * @param       len     - Length of bytes to be read/written from/to radio
 *
 * output parameters
 *
 * @return      rfStatus_t
 */
rfStatus_t trx16BitRegAccess(uint8 accessType, uint8 extAddr, uint8 regAddr, uint8 *pData, uint8 len)
{
    uint8 readValue;

    CC1120_SPI_BEGIN();

    /* send extended address byte with access type bits set */
    /* Storing chip status */
    readValue = CC1120_SPI_TXRX(accessType|extAddr);
//    printf("trx16BitRegAccess readValue: 0x%02X\n", readValue);

    CC1120_SPI_TXRX(regAddr);

    /* Communicate len number of bytes */
    trxReadWriteBurstSingle(accessType|extAddr,pData,len);

    CC1120_SPI_END();

    /* return the status byte value */
    return(readValue);
}

/*******************************************************************************
 * @fn          trxSpiCmdStrobe
 *
 * @brief       Send command strobe to the radio. Returns status byte read
 *              during transfer of command strobe. Validation of provided
 *              is not done. Function assumes chip is ready.
 *
 * input parameters
 *
 * @param       cmd - command strobe
 *
 * output parameters
 *
 * @return      status byte
 */
rfStatus_t trxSpiCmdStrobe(uint8 cmd)
{
    uint8 rc;

    CC1120_SPI_BEGIN();

    rc = CC1120_SPI_TXRX(cmd);
//    printf("trxSpiCmdStrobe cmd: 0x%02X, rc: 0x%02X\n", cmd, rc);

    CC1120_SPI_END();

    return(rc);
}

/*******************************************************************************
 * @fn          trxReadWriteBurstSingle
 *
 * @brief       When the address byte is sent to the SPI slave, the next byte
 *              communicated is the data to be written or read. The address
 *              byte that holds information about read/write -and single/
 *              burst-access is provided to this function.
 *
 *              Depending on these two bits this function will write len bytes to
 *              the radio in burst mode or read len bytes from the radio in burst
 *              mode if the burst bit is set. If the burst bit is not set, only
 *              one data byte is communicated.
 *
 *              NOTE: This function is used in the following way:
 *
 *              TRXEM_SPI_BEGIN();
 *              while(TRXEM_PORT_IN & TRXEM_SPI_MISO_PIN);
 *              ...[Depending on type of register access]
 *              trxReadWriteBurstSingle(uint8 addr,uint8 *pData,uint16 len);
 *              TRXEM_SPI_END();
 *
 * input parameters
 *
 * @param       none
 *
 * output parameters
 *
 * @return      void
 */
static void trxReadWriteBurstSingle(uint8 addr,uint8 *pData,uint16 len)
{
	uint16 i;

	/* Communicate len number of bytes: if RX - the procedure sends 0x00 to push bytes from slave*/
    if(addr&RADIO_READ_ACCESS)
    {
        if(addr&RADIO_BURST_ACCESS)
        {
            for (i = 0; i < len; i++)
            {
                /* Possible to combining read and write as one access type */
                *pData = CC1120_SPI_TXRX(0);     /* Store pData from last pData RX */
//                printf("trxReadWriteBurstSingle *pData: 0x%02X\n", *pData);
                pData++;
            }
        }
        else
        {
            *pData = CC1120_SPI_TXRX(0);
//            printf("trxReadWriteBurstSingle *pData: 0x%02X\n", *pData);
        }
    }
    else
    {
        if(addr&RADIO_BURST_ACCESS)
        {
            /* Communicate len number of bytes: if TX - the procedure doesn't overwrite pData */
            for (i = 0; i < len; i++)
            {
                CC1120_SPI_TXRX(*pData);
                pData++;
            }
        }
        else
        {
            CC1120_SPI_TXRX(*pData);
        }
    }

    return;
}

