/*
 * cc2520_mango_porting.h
 */

#ifndef __CC2520_MANGO_PORTING_H
#define __CC2520_MANGO_PORTING_H

/* Includes ------------------------------------------------------------------*/

#include "hw_config.h"
#include "stm32f10x_spi.h"
#include "hal_types.h"
#include "stm32f10x_gpio.h"

/* Exported types ------------------------------------------------------------*/

/* Exported constants --------------------------------------------------------*/

/* Exported macro ------------------------------------------------------------*/

#define GPIO_PORTSOURCE_CC2520_GPIO0   GPIO_PortSourceGPIOD

#define HAL_INT_ON(x)      ;
#define HAL_INT_OFF(x)     ;
#define HAL_INT_LOCK(x)    ;
#define HAL_INT_UNLOCK(x)  ;

#define CC2520_SPI_BEGIN()  GPIO_ResetBits(g_gpio_ncs, g_gpio_pin_ncs)
#define CC2520_SPI_END()    GPIO_SetBits(g_gpio_ncs, g_gpio_pin_ncs)

// CC2520 pin assignments
#define CC2520_SAMPLED_CCA_PIN   \
                    GPIO_ReadInputDataBit(GPIO_SPI_IO, g_gpio_pin_1)
// GPIO2 are reused for RSSI Valid or TX_FRM_DONE
#define CC2520_RSSI_VALID_PIN    \
                    GPIO_ReadInputDataBit(GPIO_SPI_IO, g_gpio_pin_2)
#define CC2520_TX_FRM_DONE_PIN   \
                    GPIO_ReadInputDataBit(GPIO_SPI_IO, g_gpio_pin_2)
#define CC2520_SFD_PIN           \
                    GPIO_ReadInputDataBit(GPIO_SPI_IO, g_gpio_pin_3)

/* External variables --------------------------------------------------------*/

/* Exported functions ------------------------------------------------------- */

void   halIntOn(void);
void   halIntOff(void);
uint16 halIntLock(void);
void   halIntUnlock(uint16 key);

void CC2520_GPIO_0_Interrupt_Setting(FunctionalState  fStateE);

void CC2520_RESET_OPIN(u8 data);
void CC2520_VREG_EN_OPIN(u8 data);

void CC2520_SPI_TX(u8 data);
u8 CC2520_SPI_RX(void);
void CC2520_SPI_WAIT_RXRDY(void);

#endif  /* __CC2520_MANGO_PORTING_H */
