/*
 * (C) COPYRIGHT 2012 CRZ
 *
 * File Name : key.c
 * Author    : POOH
 * Version   : V1.0
 * Date      : 12/03/2012
 */

/* includes */

#include "hw_config.h"

/* defines */

/* variables */

/* local functions */

static bool is_key_press_state(KEY_NUM_E keyNum)
{
    if(Bit_RESET == GPIO_ReadInputDataBit(GPIO_KEY, GPIO_KEY1_PIN << keyNum))
    {
        return TRUE;
    }
    return FALSE;
}

static bool is_key_release_state(KEY_NUM_E keyNum)
{
    if(Bit_SET == GPIO_ReadInputDataBit(GPIO_KEY, GPIO_KEY1_PIN << keyNum))
    {
        return TRUE;
    }
    return FALSE;
}

/* global functions */

bool IsKeyClicked(KEY_NUM_E keyNum)
{
    static bool check_click_val[NUM_OF_KEYS] = {FALSE, };

    if(check_click_val[keyNum])
    {
        if(is_key_release_state(keyNum))
        {
            check_click_val[keyNum] = FALSE;
            return TRUE;
        }
    }
    else
    {
        if(is_key_press_state(keyNum))
        {
            check_click_val[keyNum] = TRUE;
        }
    }

    return FALSE;
}

void KEY_Test(void)
{
    printf("Press Any Key ... (if key 3 press, test exit)\n");

    while(1)
    {
        if(IsKeyClicked(KEY1))
        {
            printf("Key 1 Press\n");
        }
        if(IsKeyClicked(KEY2))
        {
            printf("Key 2 Press\n");
        }
        if(IsKeyClicked(KEY3))
        {
            printf("Key 3 Press - test done.\n");
            break;
        }
    }
}

